<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Comment (asm4cmt) ***
// LAST UPDATE: 2014/04/14
// Version    : 3.30
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// asm4cmt.php
//
//--------------------------------------------------------------------

// コメントアイコン＆絵文字モジュール用
@include(BLOGN_MODDIR."sxcicon/sxcicon.php");

blogn_mod_asm4cmt_input_comment($blogn_user, $blogn_post_cid, $blogn_post_cname, $blogn_post_cemail, $blogn_post_curl, $_POST["blogn_cmes"], $blogn_post_set_cookie, $blogn_server_remode_addr, $blogn_server_http_user_agent, $blogn_server_http_referer, $blogn_get_token, $_POST[$blogn_mod_asm4cmt_key[0]], $_POST[$blogn_mod_asm4cmt_key[1]]);

/* ----- コメント入力処理 ----- */
function blogn_mod_asm4cmt_input_comment($user, $entry_id, $name, $email = "", $url = "", $mes, $set_cookie, $ip, $agent, $referer, $token, $key_main, $key_sub) {

	require BLOGN_MODDIR."asm4cmt/function.php";
	require BLOGN_MODDIR."asm4cmt/spamchk.php";
	
	$submit_time = time();
	$display_time = "";
	if ($key_main) {
		$display_time = $key_main;
	} elseif ($key_sub) {
		$display_time = $key_sub;
	}
		
	if (!$display_time || !preg_match("/^[0-9a-f]{8}$/", $display_time)) {
		$seconds = NULL;
	} else {
		$seconds = $submit_time - hexdec($display_time);
		if ($seconds < 0) $seconds = NULL;
	}
	
	$asm4cmt_errflg = "0";
	$asm4cmt_err = "";
	$errflg = false;
	
	if (BLOGN_MBS) {
		if (BLOGN_CHARSET == 0 || BLOGN_MOBILE_KEY == 1) {
			$name = mb_convert_kana($name, "KV", "SJIS");
			$mes = mb_convert_kana($mes, "KV", "SJIS");
		} elseif (BLOGN_CHARSET == 1) {
			$name = mb_convert_kana($name, "KV", "EUC-JP");
			$mes = mb_convert_kana($mes, "KV", "EUC-JP");
		} else {
			$name = mb_convert_kana($name, "KV", "UTF-8");
			$mes = mb_convert_kana($mes, "KV", "UTF-8");
		}
	}
	$utf_name = asm4cmt_remove_rn(blogn_mbConv($name, 0, 4));
	if (preg_match("/^(\s)*#/", $utf_name)) $utf_name = "";
	$utf_email = asm4cmt_remove_rn(blogn_mbConv($email, 0, 4));
	if ($url) {
		$utf_url = asm4cmt_remove_rn(blogn_mbConv($url, 0, 4));
		$utf_url = "http://".str_replace("http://", "", $utf_url);
	}
	$utf_mes = blogn_mbConv(rtrim($mes), 0, 4);
	$asc_mes = $utf_mes;
	
	$blogn_entry_url = BLOGN_HOMELINK."index.php?e=".$entry_id;

//	if (strpos($agent, "Maxthon")) $errflg = true;
//	if (strpos($agent, "TencentTraveler")) $errflg = true;

	if (!$entry_id && !is_numeric($entry_id)) { // 記事IDチェック
		$errflg = true;
		exit();
	} elseif (!$utf_name || !$utf_mes) { // 投稿者名・本文チェック
		$errflg = true;
	} elseif (!$seconds || $seconds < 12 || $seconds > 86400) { // 投稿時間チェック
		$errflg = true;
	} else {
		$logdata = blogn_mod_db_log_load_for_editor($entry_id);
		$diffdays = blogn_date_diff($logdata[1]["date"]);
		if (BLOGN_LIMIT_COMMENT && BLOGN_LIMIT_COMMENT < $diffdays) {
			$errflg = true;
		} else {
			if (strlen($utf_mes) > BLOGN_COMMENT_SIZE && BLOGN_COMMENT_SIZE != 0) $utf_mes = blogn_mbtrim($utf_mes,BLOGN_COMMENT_SIZE);
			if ($user) {
				$comment = blogn_mod_db_comment_load_for_new(1, 0, 10);
			} else {
				$comment = blogn_mod_db_comment_load_for_new(0, 0, 10);
			}

			// 重複投稿チェック
			if ($comment[0]) {
				while (list($key, $val) = each($comment[1])) {
					if ($val["name"] == $utf_name && strip_tags($val["comment"]) == strip_tags( blogn_mod_db_rn2br($utf_mes))) {
						$errflg = true;
						break;
						exit();
					}
				}
			}
		}
	}

/*
	if (file_exists(BLOGN_MODDIR."captcha/viewer.php")) {
		// キャプチャ・チェック
		include (BLOGN_MODDIR."captcha/viewer.php");
		blogn_mod_captcha_check($captcha_errflg, $info, $link_url, $entry_id);
		if ($captcha_errflg) {
			$errflg = "true";
		}
	}
*/

	if (!$errflg) {
		$inifile = BLOGN_MODDIR."asm4cmt/config.cgi";
		$inis = file($inifile);
		list($mode, $spm_limit, $cmt[0]["allow"], $cmt[0]["log"], $cmt[0]["mail"], $cmt[1]["allow"], $cmt[1]["log"], $cmt[1]["mail"], $cmt[2]["allow"], $cmt[2]["log"], $cmt[2]["mail"]) = explode(",", $inis[0]);
		list($language, $urls, $difference, $wt["lang"], $wt["href"], $wt["bburl"], $wt["bblink"], $wt["atmark"], $wt["https"], $wt["time"], $wt["mail"], $wt["urlincmt"], $wt["redirect"], $wt["ngwd"], $wt["blip"], $wt["proxy"], $wt["badref"], $wt["badua"], $wt["token"], $wt["name"], $wt["eml"]) = explode(",", $inis[1]);
		list($name_limit, $trip, $autolink, $quote, $mailcmt, $cap) = explode(",", $inis[2]);

		// 投稿者名から特定の記号を変換
		$array1 = array ("◆","■","▲","▼","●","★","＃");
		$array2 = array ("◇","□","△","▽","○","☆","#");
		$utf_name = str_replace($array1, $array2, $utf_name);

		// キャップ機能
		if ($cap == "capon") {
			if (preg_match("/^(\#|＃)(.+)$/", $utf_email, $email_match)) {
				$cap_list = file(BLOGN_MODDIR."asm4cmt/caps.cgi");
				$cap_count = count($cap_list);
				$i = 0;
				for ($i = 0; $i < $cap_count; $i++) {
					list($cap_pass, $cap_cap) = explode("=", trim($cap_list[$i]));
					if ($email_match[2] == $cap_pass) {
						$utf_name = $cap_cap."★";
						$trip = "";
						break;
					}
				}
				$utf_email = "";
				$cap = "capped";
			}
		} else {
			if (preg_match("/^(\#|＃)(.+)$/", $utf_email)) {
				$utf_email = "";
			}
		}
		// メールに @ が含まれていない場合、空にする（キャップパス漏れ防止）
		$pos = '';
		$pos = strpos($utf_email, "@");
		if ($pos === false) $utf_email = "";

		$new_error = antispam_check($asc_mes, $utf_name, $utf_email, $utf_url, $seconds, $ip, $referer, $entry_id, $agent, $token, $mode, $language, $urls, $difference, $wt, "e");
		$asm4cmt_errflg = $new_error["penalty"];
		$asm4cmt_err = $new_error["reason"];
		if ($new_error["del"]) $errflg = true;

		if ($trip == "tripon") { // トリップ機能＋投稿者名文字数制限
			if (preg_match("/([^\#]*)\#(.+)/", $utf_name, $match)) {
				$salt = substr($match[2]."H.", 1, 2);
				$salt = preg_replace("/[^\.-z]/", ".", $salt);
				$salt = strtr($salt, "\x3A-\x40\x5B-\x60\x00-\x2D\x7B-\xFF","A-Ga-f.");
				$trip = substr(crypt($match[2], $salt),-10);
				$match[1] = asm4cmt_namelimit($match[1], $name_limit);
				$utf_name = $match[1]."◆".$trip;
			} else {
				$utf_name = asm4cmt_namelimit($utf_name, $name_limit);
			}
		} elseif ($cap != "capped") {
			$pos = "";
			$pos = strpos($utf_name, "#");
			if ($pos === false) {
				$utf_name = asm4cmt_namelimit($utf_name, $name_limit);
			} else {
				preg_match("/([^\#]*)\#(.+)/", $utf_name, $match);
				$utf_name = asm4cmt_namelimit($match[1], $name_limit);
			}
		}

		$utf_mes = blogn_html_tag_convert($utf_mes);
		$utf_mes = str_replace("-----", "&#x2d;---&#x2d;", $utf_mes);
	
		if ($autolink != "nolink") {
			$utf_mes = asm4cmt_autolink($utf_mes, $autolink);
		}

		// 引用
		if ($quote == "quoteon") {
			$message = asm4cmt_quote($utf_mes);
		} else {
			$message = $utf_mes;
		}
	}

	$date = gmdate("YmdHis", time() + BLOGN_TIMEZONE);

	switch (TRUE) { // ペナルティ値による分岐処理
		case ($asm4cmt_errflg > $spm_limit) : // スパム（高）
			$asmc_action = array($cmt[2]["allow"], $cmt[2]["log"], $cmt[2]["mail"], "high");
			break;
		case ($asm4cmt_errflg >= 10) : // スパム（低）
			$asmc_action = array($cmt[1]["allow"], $cmt[1]["log"], $cmt[1]["mail"], "low");
			break;
		default : // ハム
			$asmc_action = array($cmt[0]["allow"], $cmt[0]["log"], $cmt[0]["mail"], "ham");
			break;
	}
	
	$refresh = "10";
	if (!$errflg) {
		switch ($asmc_action[0]) { // コメントの扱い
			case "2": // 削除
				$link_url = $blogn_entry_url."#comments";
				$info = '<p><b>コメント投稿エラー</b><br />投稿内容に不備等があったため、<br />投稿に失敗しました。</p><p>画面が自動的に切り替わらない場合は<br /><a href="'.$link_url.'">こちら</a>をクリックしてください。</p><hr /><p><b>投稿内容</b></p><p style="text-align:left;padding:10px;border:inset 2px #cccccc;font-size:90%;">'.str_replace("\n", "<br />", strip_tags($utf_mes)).'</p>';
				$refresh = "120";
				break;
			case "1": // 保留
				$asm4cmt_err = '{保留}'.$asm4cmt_err;
				$link_url = $blogn_entry_url."#comments";
				$info = '<p><b>コメントは保留されました。</b><br />管理人承認後、公開されます。</p><p>画面が自動的に切り替わらない場合は<br /><a href="'.$link_url.'">こちら</a>をクリックしてください。</p>';
				break;
			case "0": // 許可
			default:
				$error = blogn_mod_db_comment_add($entry_id, $logdata[1]["secret"], $date, blogn_html_tag_convert($utf_name), blogn_html_tag_convert($utf_email), blogn_html_tag_convert($utf_url), $message, $ip, $agent);
				$link_url = $blogn_entry_url."#cmt".$error[2];
				$info = '<p><b>コメントを投稿しました。</b></p><p>画面が自動的に切り替わらない場合は<br /><a href="'.$link_url.'">こちら</a>をクリックしてください。</p>';
				break;
		}
		switch ($asmc_action[1]) { // ログへの記録
			case "1": // しない
				break;
			case "0": // する
			default:
				blogn_mod_asm4cmt_record_log($entry_id, $asm4cmt_err, $date, $utf_name, $utf_email, $utf_url, $message, $ip, $agent, $referer, $seconds, $asm4cmt_errflg);
				break;
		}
		switch ($asmc_action[2]) { // メール
			case "1": // 非通知
				break;
			case "0": // 通知
			default:
				$userlist = blogn_mod_db_user_load();
				$logdata = blogn_mod_db_log_load_for_editor($entry_id);
				if ($asmc_action[0] == "0") {
					$sub = '[ID:'.$entry_id.'] コメント受信 - '.$logdata[1]["title"];
				} else {
					$sub = '[ID:'.$entry_id.'] コメント保留 - '.$logdata[1]["title"];
				}
				$sub = blogn_mbConv($sub, 4, 3);
				$sub = "=?iso-2022-jp?B?".base64_encode($sub)."?="; 
				$mes = "件名:".$logdata[1]["title"]."\n"; 
				$mes .= "投稿者名:".$utf_name."\n"; 
				$mes .= "URL:".$blogn_entry_url."#comments\n"; 
				$mes .= "※このメールアドレスには返信しないでください。\n\n";
				if ($mailcmt == "comment") {
					$utf_mes = str_replace("<br />", "\n", $utf_mes);
					$utf_mes = str_replace("&#x2d;---&#x2d;", "-----", $utf_mes);
					$mes .= strip_tags(blogn_html_tag_restore($utf_mes));
				}
				$mes = blogn_mbConv($mes, 4, 3); 
				$from = BLOGN_SITENAME; 
				$from = blogn_mbConv($from, 4, 3); 
				$from = "=?iso-2022-jp?B?".base64_encode($from)."?="; 
				$from = "From: $from <blognplus@localhost>\nContent-Type: text/plain; charset=\"iso-2022-jp\""; 
				while (list($key, $val) = each($userlist)) {
					if ($val["information_comment"]) @mail($val["information_mail_address"], $sub, $mes, $from); 
				}
				break;
		}
	} else {
		$link_url = $blogn_entry_url."#comments";
		$info = '<p><b>コメント投稿エラー</b><br />投稿内容に不備等があったため、<br />投稿に失敗しました。</p><p>画面が自動的に切り替わらない場合は<br /><a href="'.$link_url.'">こちら</a>をクリックしてください。</p><hr /><p><b>投稿内容</b></p><p style="text-align:left;padding:10px;border:inset 2px #cccccc;font-size:90%;">'.str_replace("\n", "<br />", strip_tags($utf_mes)).'</p>';
		$refresh = "200";
	}



	if (BLOGN_CHARSET == 0 || BLOGN_MOBILE_KEY == 1) {
		$charset = "Shift_JIS";
		$outkey = 2;
	}elseif (BLOGN_CHARSET == 1) {
		$charset = "EUC-JP";
		$outkey = 1;
	} elseif (BLOGN_CHARSET == 2) {
		$charset = "UTF-8";
		$outkey = 4;
	}

	$errdata = '
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<meta http-equiv="refresh"content="'.$refresh.';URL='.$link_url.'">
<meta http-equiv=content-type content="text/html; charset='.$charset.'">
</head>
<body>
<div align="center">		
<div style="text-align:center;border:1px solid;width:500px;padding:0.5em;">
'.$info.'
</div>
</div>

</body>
</html>';


	if ($set_cookie == "on") {
		setcookie("name", blogn_mbConv($name, 0, 4), time() + BLOGN_TIMEZONE + 604800);
		setcookie("email", blogn_mbConv($email, 0, 4), time() + BLOGN_TIMEZONE + 604800);
		setcookie("url", blogn_mbConv($url, 0, 4), time() + BLOGN_TIMEZONE + 604800);
	}

	header("Content-Type: text/html; charset=$charset");
	if ($outkey != 4) $errdata = blogn_mbConv($errdata, 4, $outkey);
	if ($outkey == 2) $errdata = blogn_magic_quotes($errdata);
	echo $errdata;
	exit;
}

/* ----- ログ書き込み ----- */
function blogn_mod_asm4cmt_record_log($entry_id, $asm4cmt_err, $date, $utf_name, $utf_email, $utf_url, $utf_mes, $ip, $agent, $referer, $seconds, $asm4cmt_errflg) {
	$asm4cmt_file = BLOGN_MODDIR."asm4cmt/rejected.cgi";
	$fp = fopen("$asm4cmt_file", "a+");
	flock($fp, LOCK_EX);
	$asm4cmt_data = $entry_id.','.$asm4cmt_err.','.$date.','.asm4cmt_format_data($utf_name).','.asm4cmt_format_data($utf_email).','.blogn_html_tag_convert($utf_url).','.blogn_mod_db_comma_change(blogn_mod_db_rn2br($utf_mes)).','.$ip.','.asm4cmt_format_log($agent).','.asm4cmt_format_log($referer).','.$seconds.','.$asm4cmt_errflg.",\n";
	fwrite($fp, $asm4cmt_data);
	flock($fp, LOCK_UN);
	fclose($fp);
}

?>
