<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Comment (asm4cmt) ***
// LAST UPDATE: 2014/04/14
// Version    : 3.30
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// spamchk.php
//
//--------------------------------------------------------------------

function antispam_check ($utf_mes, $utf_name, $utf_email, $utf_url, $seconds, $ip, $referer, $id, $ua, $token, $mode, $language, $urls, $difference, $wt, $ebbs) {

	$error = array("penalty" => 0, "reason" => "", "del" => false);
	if ($mode != 3) {
		// 日本語チェック
		if ($wt["lang"]) {
			if ($language == "engng") {
				if (!preg_match("/[ぁ-んァ-ヶ一-龍]{15}/", $utf_mes)) {
					$error["penalty"] += $wt["lang"];
					$error["reason"] .= "[非日本語]";
					if ($wt["lang"] == 11) $error["del"] = true;
				}
			} elseif ($language == "chnng") {
				if (!preg_match("/[ぁ-んァ-ヶ]{9}/", $utf_mes)) {
					$error["penalty"] += $wt["lang"];
					$error["reason"] .= "[非日本語]";
					if ($wt["lang"] == 11) $error["del"] = true;
				}
			}
		}

		// タイムスタンプチェック
		if ($seconds <= $difference && !$error["del"]) {
			$error["penalty"] += $wt["time"];
			$error["reason"] .= "[投稿時間]";
			if ($wt["time"] == 11) $error["del"] = true;
		}

		// トークンチェック
		if (BLOGN_MOBILE_KEY) { // 携帯
			if ($_SERVER['HTTP_X_UP_SUBNO']) {
				$uid = htmlspecialchars(strip_tags($_SERVER['HTTP_X_UP_SUBNO'])); // AU
			} elseif($_SERVER['HTTP_X_JPHONE_UID']) {
				$uid = htmlspecialchars(strip_tags($_SERVER['HTTP_X_JPHONE_UID'])); // Softbank
			} else {
				$uid = htmlspecialchars(strip_tags($_SERVER['HTTP_USER_AGENT']));
			}
			if ($token != md5($uid) && $error["del"]) {
				$error["penalty"] += $wt["token"];
				$error["reason"] .= "[トークン]";
				if ($wt["token"] == 11) $error["del"] = true;
			}
		} else { // PC
			if ($_SESSION["asm4cmt_token"] != $token && !$error["del"]) {
				$error["penalty"] += $wt["token"];
				$error["reason"] .= "[トークン]";
				if ($wt["token"] == 11) $error["del"] = true;
			}
		}

		// コメント内に投稿者名
		if (mb_strpos($utf_mes, $utf_name) !== false && !$error["del"]) {
			$error["penalty"] += $wt["name"];
			$error["reason"] .= "[投稿者名]";
			if ($wt["name"] == 11) $error["del"] = true;
		}
			
		// コメント内に HREF
		if (preg_match("/href=/i", $utf_mes) && !$error["del"]) {
			$error["penalty"] += $wt["href"];
			$error["reason"] .= "[リンク (HREF=)]";
			if ($wt["href"] == 11) $error["del"] = true;
		}
	
		// コメント内に BBCode でリンク（URL=）
		if (preg_match("/\[url/i", $utf_mes) && !$error["del"]) {
			$error["penalty"] += $wt["bburl"];
			$error["reason"] .= "[リンク (URL=)]";
			if ($wt["bburl"] == 11) $error["del"] = true;
		}

		// コメント内に BBCode でリンク（LINK=）
		if (preg_match("/\[link/i", $utf_mes) && !$error["del"]) {
			$error["penalty"] += $wt["bblink"];
			$error["reason"] .= "[リンク (LINK=)]";
			if ($wt["bblink"] == 11) $error["del"] = true;
		}

		// コメント内にメールアドレス
		if (preg_match("/[a-zA-Z0-9_\.\-]+?@[A-Za-z0-9_\.\-]+/", $utf_mes) && !$error["del"]) {
			$error["penalty"] += $wt["atmark"];
			$error["reason"] .= "[@]";
			if ($wt["atmark"] == 11) $error["del"] = true;
		}

		// http の数をカウント
		$https_count = substr_count(strtolower($utf_mes), "http");
		if ($urls <= $https_count && !$error["del"]) {
			$error["penalty"] += $wt["https"];
			$error["reason"] .= "[URL羅列]";
			if ($wt["https"] == 11) $error["del"] = true;
		}

		// メールとURL
		if ($utf_email && $utf_url && !$error["del"]) {
			$error["penalty"] += $wt["mail"];
			$error["reason"] .= "[MAIL+URL]";
			if ($wt["mail"] == 11) $error["del"] = true;
		}

		// メール
		if ($utf_email && !$error["del"]) {
			$error["penalty"] += $wt["eml"];
			$error["reason"] .= "[E-MAIL]";
			if ($wt["eml"] == 11) $error["del"] = true;
		}

		// コメントに URL 欄と同じ URL があるかチェック
		if ($utf_url && !$error["del"]) {
			$purl = parse_url($utf_url);
			if (stristr($utf_mes, $purl["host"])) {
				$error["penalty"] += $wt["urlincmt"];
				$error["reason"] .= "[重複URL]";
				if ($wt["urlincmt"] == 11) $error["del"] = true;
			}
		}

		// リファラ（ドコモは除外）
		$pos = strpos($ua, "DoCoMo");
		if ($pos === false && !$error["del"]) {
			$purl = parse_url($referer);
			$qurl = preg_split("/[=&]/", $purl["query"]);
			if(!stristr(BLOGN_HOMELINK, $purl["host"]) || $qurl[0] != "e" || $qurl[1] != $id) {
				$error["penalty"] += $wt["badref"];
				$error["reason"] .= "[リファラ]";
				if ($wt["badref"] == 11) $error["del"] = true;
			}
		}

		$badua = strpos($ua, "/");
		if ($badua === false && !$error["del"]) {
			$badua = strpos($ua, ";");
			if  ($badua === false) {
				$error["penalty"] += $wt["badua"];
				$error["reason"] .= "[不正UA]";
				if ($wt["ua"] == 11) $error["del"] = true;
			}
		}
			
		// 使用禁止ワードチェック
		if (!$error["del"]) {
			$data = fopen(BLOGN_MODDIR."asm4cmt/ngwd.cgi", "r");
			$ng_wd = fgets($data, 2048);
			if (strlen($ng_wd)) {
				$ng_wd = preg_replace("/[,]+$/", "", $ng_wd);
				$ng_wd = explode(",", $ng_wd);
				if (is_array($ng_wd)) {
					foreach ($ng_wd as $deny_wd) {
						if (preg_match("/$deny_wd/i", $utf_mes) || preg_match("/$deny_wd/i", $utf_url) || preg_match("/$deny_wd/i", $utf_name)) {
							$error["penalty"] += $wt["ngwd"];
							$error["reason"] .= "[禁止ワード]";
							if ($wt["ngword"] == 11) $error["del"] = true;
						}
					}
				}
			}
			fclose($data);
		}

		// リンク先のチェック
		if ($wt["redirect"] && $utf_url && !$error["del"]) {
			$page = strip_tags(get_html($utf_url), '<meta>'); //URLからHTMLを取得
			if (!$page) {
				$utf_url ="";
			} else {
				$page = htmlspecialchars($page);
				$page = substr($page, 0, 2000);
				if (preg_match("/Location: http:/i", $page)) {
					$error["penalty"] += $wt["redirect"];
					$error["reason"] .= "[リダイレクト]";
					if ($wt["redirect"] == 11) $error["del"] = true;
				} elseif (preg_match("/http-equiv=(&quot;|'){0,1}refresh(&quot;|'){0,1}/i", $page)) {
					$error["penalty"] += $wt["redirect"];
					$error["reason"] .= "[リダイレクト]";
					if ($wt["redirect"] == 11) $error["del"] = true;
				}
			}
		}

		// ブラックリストに登録されているかチェック
		preg_match("/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/", $ip, $ips);
		$domain = $ips[4].'.'.$ips[3].'.'.$ips[2].'.'.$ips[1];
		if ($wt["proxy"] && !$error["del"]) {
			if (strstr(gethostbyname($domain.'.niku.2ch.net'), "127.0.0")) {
				$error["penalty"] += $wt["proxy"];
				$error["reason"] .= "[プロキシ]";
				if ($wt["proxy"] == 11) $error["del"] = true;
			}
		}	
//		if ($wt["blip"] && !$error["del"]) {
//			if (strstr(gethostbyname($domain.'.bsb.spamlookup.net'), "127.0.0")) {
//				$error["penalty"] += $wt["blip"];
//				$error["reason"] .= "[IP（BSB）]";
//				if ($wt["blip"] == 11) $error["del"] = true;
//			}
//		}
		// スパムちゃんぷるー
		if ($wt["blip"] && !$error["del"]) {
			if (strstr(gethostbyname($domain.'.dnsbl.spam-champuru.livedoor.com'), "127.0.0")) {
				$error["penalty"] += $wt["blip"];
				$error["reason"] .= "[IP（Livedoor）]";
				if ($wt["blip"] == 11) $error["del"] = true;
			}
		}


	} else {
		$error["penalty"] = "0";
		$error["reason"] = "";
	}

	return $error;
}

?>